<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TemperatureSelection StructType
 * @subpackage Structs
 */
class TemperatureSelection extends AbstractStructBase
{
    /**
     * The IncludeMeasurementsData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeMeasurementsData;
    /**
     * The Vehicles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Vehicles;
    /**
     * The DateTimeRange
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeRangeSelection
     */
    public $DateTimeRange;
    /**
     * Constructor method for TemperatureSelection
     * @uses TemperatureSelection::setIncludeMeasurementsData()
     * @uses TemperatureSelection::setVehicles()
     * @uses TemperatureSelection::setDateTimeRange()
     * @param bool $includeMeasurementsData
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @param \StructType\DateTimeRangeSelection $dateTimeRange
     */
    public function __construct($includeMeasurementsData = null, \ArrayType\ArrayOfIdentifierVehicle $vehicles = null, \StructType\DateTimeRangeSelection $dateTimeRange = null)
    {
        $this
            ->setIncludeMeasurementsData($includeMeasurementsData)
            ->setVehicles($vehicles)
            ->setDateTimeRange($dateTimeRange);
    }
    /**
     * Get IncludeMeasurementsData value
     * @return bool
     */
    public function getIncludeMeasurementsData()
    {
        return $this->IncludeMeasurementsData;
    }
    /**
     * Set IncludeMeasurementsData value
     * @param bool $includeMeasurementsData
     * @return \StructType\TemperatureSelection
     */
    public function setIncludeMeasurementsData($includeMeasurementsData = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeMeasurementsData) && !is_bool($includeMeasurementsData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeMeasurementsData, true), gettype($includeMeasurementsData)), __LINE__);
        }
        $this->IncludeMeasurementsData = $includeMeasurementsData;
        return $this;
    }
    /**
     * Get Vehicles value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getVehicles()
    {
        return $this->Vehicles;
    }
    /**
     * Set Vehicles value
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @return \StructType\TemperatureSelection
     */
    public function setVehicles(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this->Vehicles = $vehicles;
        return $this;
    }
    /**
     * Get DateTimeRange value
     * @return \StructType\DateTimeRangeSelection|null
     */
    public function getDateTimeRange()
    {
        return $this->DateTimeRange;
    }
    /**
     * Set DateTimeRange value
     * @param \StructType\DateTimeRangeSelection $dateTimeRange
     * @return \StructType\TemperatureSelection
     */
    public function setDateTimeRange(\StructType\DateTimeRangeSelection $dateTimeRange = null)
    {
        $this->DateTimeRange = $dateTimeRange;
        return $this;
    }
}
